#ifndef __DMAGIF_H__
#define __DMAGIF_H__


#include "dmawrap.h"


class CDmaGif : public CDmaWrap
{
public:
	CDmaGif(void * pDmaMem, uint32 uDmaQuadSize, TRANS_MODE trans_mode=TRANS_CHAINED) : CDmaWrap(pDmaMem,uDmaQuadSize,trans_mode) {}

	void Launch(int iSPS2Device=-1);
	void Wait();

private:
};




inline void CDmaGif::Launch(int iSPS2Device)
{
	asm("sync.l");
	assert(((*EE_D2_CHCR)&0x0100) == 0);

	switch(m_uTransMode)
	{
		case TRANS_NORMAL:
			*EE_D2_MADR = (uint32) (m_pStartPhys)&0x8fffffff;
			*EE_D2_QWC = (uint32) m_uDmaQuadSize;
			
			#ifdef DEBUG_DMA
			if (iSPS2Device>=0) {
			  sps2ValidateDMA(iSPS2Device,2,GenCHCR(0,0,0,0,0,1),0);
			}
			#endif

			*EE_D2_CHCR = GenCHCR(0,0,0,0,0,1);
			break;
		case TRANS_CHAINED:
			*EE_D2_QWC = 0;
			*EE_D2_TADR = ((uint32) m_pStartPhys)&0x8fffffff;

			#ifdef DEBUG_DMA
			if (iSPS2Device>=0) {
			  sps2ValidateDMA(iSPS2Device,2,GenCHCR(0,1,0,0,0,1),0);
			}
			#endif

			*EE_D2_CHCR = GenCHCR(0,1,0,0,0,1);
			break;
		default:
			assert(false);	// unknown specification
	}

	asm("sync.l");
}

inline void CDmaGif::Wait()
{
	while((*EE_D2_CHCR)&0x0100)
		;
}



#endif
