#include <assert.h>
#include <stdio.h>
#include "exttypes.h"
#include "sps2lib.h"


#define SPR			0x00000000

#define GEN_REF_TAG(Addr, iQuadCount)			((uint64(Addr) << 32) | (0x3 << 28) | iQuadCount)
#define GEN_END_TAG(iQuadCount)					((uint64(0x7) << 28) | iQuadCount)
#define GEN_CNT_DSTTAG(Addr, iQuadCount)		((uint64(Addr) << 32) | (0x1 << 28) | iQuadCount)
#define GEN_END_DSTTAG(Addr, iQuadCount)		((uint64(Addr) << 32) | (0x7 << 28) | iQuadCount)

// PS2Linux stuff

// GoTeamGo!!!
extern "C" void VU_vu0matmulmat_start(void);
extern "C" void VU_vu0matmulmat_end(void);


uint32 uPollNumber;
const uint32 uSpMatBase = SPR;
uint32 uMatBufToggle;

// Ref Chains
uint64 * pToChain;
uint64 * pToPhysChain;

// Working vars
const uint32 uMaxMatArrayLens = 56;	// in matrices (units of 48 bytes)
const uint32 uOffsToLocalDst = uMaxMatArrayLens*(2*12*4);
uint32 uLastNumMats;
uint32 uLastPageIndex;
uint32 uLastStartOffs;

// Physical addr lookup-tables
uint32 * PhysArraySrc1;
uint32 * PhysArraySrc2;
uint32 * PhysArrayDst;


void VU0ExecMats(void * pSrc1, void * pSrc2, void * pDst, uint32 uNumMats)
{
	uint128 uVal1, uVal2, uVal3, uVal4;

	asm __volatile__ ("	
						.set noreorder
						mtsah	$0, 2
						.align 4

						# first half init
						lq		%2, 0(%4)
						lq		%0, 16(%4)
						lq		%3, 32(%4)
						qfsrv	%1, $0, %2
						lqc2	vf05, 0(%5)
						move	%1, %0
						lqc2	vf06, 16(%5)
						pexew	%1, %1
						lqc2	vf07, 32(%5)
						pexcw	%1, %1
						qmtc2	%2, vf01
						pcpyud	%0, %0, $0
						qmtc2	%1, vf02
						pcpyld	%0, %3, %0
						qmtc2	%0, vf03
						qfsrv	%3, $0, %3
						qmtc2	%3, vf04
						addu	%4, %4, 12*4
						vcallms	0x0
						addu	%5, %5, 12*4

						# second half init
						lq		%2, 0(%4)
						lq		%0, 16(%4)
						lq		%3, 32(%4)
						qfsrv	%1, $0, %2
						lqc2	vf25, 0(%5)
						move	%1, %0
						lqc2	vf26, 16(%5)
						pexew	%1, %1
						lqc2	vf27, 32(%5)
						pexcw	%1, %1
						qmtc2	%2, vf21
						pcpyud	%0, %0, $0
						qmtc2	%1, vf22
						pcpyld	%0, %3, %0
						qmtc2	%0, vf23
						qfsrv	%3, $0, %3
						qmtc2	%3, vf24
						addu	%4, %4, 12*4
						vcallms	0x68
						addu	%5, %5, 12*4


						.align 4
0:
						# first half
						lq		%2, 0(%4)
						nop

						lq		%0, 16(%4)
						nop

						lq		%3, 32(%4)
						qfsrv	%1, $0, %2

						lqc2	vf05, 0(%5)
						move	%1, %0

						lqc2	vf06, 16(%5)
						pexew	%1, %1

						lqc2	vf07, 32(%5)
						pexcw	%1, %1

						qmtc2	%2, vf01
						pcpyud	%0, %0, $0

						qmtc2	%1, vf02
						pcpyld	%0, %3, %0

						qmtc2	%0, vf03
						qfsrv	%3, $0, %3

						qmtc2	%3, vf04
						subu	%7, %7, 1
						
						vcallms	0x0
						addu	%4, %4, 12*4

						sqc2	vf12, 0(%6)
						addu	%5, %5, 12*4

						sqc2	vf13, 16(%6)
						addu	%6, %6, 12*4

						beq		%7, $0, 1f
						sqc2	vf14, 32-12*4(%6)
						
						
						# Second half
						lq		%2, 0(%4)
						nop

						lq		%0, 16(%4)
						nop

						lq		%3, 32(%4)
						qfsrv	%1, $0, %2

						lqc2	vf25, 0(%5)
						move	%1, %0

						lqc2	vf26, 16(%5)
						pexew	%1, %1

						lqc2	vf27, 32(%5)
						pexcw	%1, %1

						qmtc2	%2, vf21
						pcpyud	%0, %0, $0

						qmtc2	%1, vf22
						pcpyld	%0, %3, %0

						qmtc2	%0, vf23
						qfsrv	%3, $0, %3

						qmtc2	%3, vf24
						subu	%7, %7, 1
						
						vcallms	0x68
						addu	%4, %4, 12*4

						sqc2	vf15, 0(%6)
						addu	%5, %5, 12*4

						sqc2	vf16, 16(%6)
						addu	%6, %6, 12*4

						bgtz	%7, 0b
						sqc2	vf17, 32-12*4(%6)
1:						
						
						# The End
						
						.set reorder"
							: "=&r" (uVal1),  "=&r" (uVal2), "=&r" (uVal3), "=&r" (uVal4) : "r"(pSrc1), "r"(pSrc2), "r"(pDst), "r" (uNumMats) : "%4", "%5", "%6", "%7");
}


bool SetupDstTags(uint64 * pTag1, uint64 * pTag2);
void SetupSrcChain(uint32 uPageIndex, uint32 uStartOffs, uint32 uNumMats);

void ExecDMA_Mats(uint32 uPageIndex, uint32 uStartOffs, uint32 uNumMats, uint32 uFlushNum=0)
{
	// Figure out which channels to use during this run
	bool bToSet = false;
	bool bFromSet = false;
	if(uPollNumber>1 && uFlushNum == 0)	// two launches
	{
		bToSet = true;
		bFromSet = true;
	}
	else if(uFlushNum == 0)		// Only making a delivery (toSp)
		bToSet = true;
	else if(uPollNumber>1 && uFlushNum == 1)	// Only writing back result (fromSp)
		bFromSet = true;

	// Sync
	asm("sync.l");

	// Launch result from ScratchPad
	if(bFromSet)
	{
		uint32 uSendMatFrmSp = uSpMatBase + uMatBufToggle + uOffsToLocalDst;
		while ((*EE_D8_CHCR) & (1 << 8));		// Wait for Channel

		*EE_D8_QWC = 0;
		*EE_D8_SADR = (uint32) (uSendMatFrmSp & 0x3fff);
	}

	// Launch new batch to ScratchPad
	if(bToSet)
	{
		uint32 uSendMatToSp = uSpMatBase + uMatBufToggle;
		while ((*EE_D9_CHCR) & (1 << 8));		// Wait for Channel

		SetupSrcChain(uPageIndex, uStartOffs, uNumMats);
		
		*EE_D9_QWC = 0;
		*EE_D9_TADR= (uint32) pToPhysChain&0x0fffffff;
		*EE_D9_SADR = (uint32) uSendMatToSp&0x3fff;
	}

	// Execute DMA
	if(bFromSet)
		*EE_D8_CHCR = 0x0104;
	if(bToSet)
		*EE_D9_CHCR = 0x0104;	// chained

	asm("sync.l");

	// Execute current Mats
	if(uPollNumber>0 && uFlushNum<2)
	{
		// Find ScratchPad sources and destination
		float * pSrc1 = (float *) (uSpMatBase + (uMatBufToggle^0x2000));
		float * pSrc2 = (float *) (uint32(pSrc1) + uLastNumMats*(12*4));
		uint64 * pTagDst = (uint64 *) (uint32(pSrc1) + uOffsToLocalDst);
		float * pDst = ((float *) pTagDst) + 4;	// increment by size of one Tag

		uint64 uTag1, uTag2;
		bool bGotPageCrossing = SetupDstTags(&uTag1, &uTag2);

		// insert first Tag
		pTagDst = (uint64 *) (uint32(pTagDst)+uint32(SCRATCH_PAD));
		pTagDst[0] = uTag1; pTagDst[1] = 0;

		// Run interlock
		// SCRATCH_PAD
		if(!bGotPageCrossing)
			VU0ExecMats((void *) (uint32(pSrc1)+uint32(SCRATCH_PAD)), (void *) (uint32(pSrc2)+uint32(SCRATCH_PAD)), (void *) (uint32(pDst)+uint32(SCRATCH_PAD)), uLastNumMats);
		else
		{
			// QuadCount divided by 3 equals amount of matrices in first batch
			uint32 uQCnt1 = uTag1&0xffff;
			uint32 uNumMats1 = uQCnt1/3;	// have to fix this slow integer division thing!
			uint32 uModMats1 = uQCnt1%3;

			if(uModMats1!=0) ++uNumMats1;	// fix border problem

			VU0ExecMats((void *) (uint32(pSrc1)+uint32(SCRATCH_PAD)), (void *) (uint32(pSrc2)+uint32(SCRATCH_PAD)), (void *) (uint32(pDst)+uint32(SCRATCH_PAD)), uNumMats1);

			uint32 uOffsBuf = (uNumMats1*3)<<2;
			pSrc1 += uOffsBuf; pSrc2 += uOffsBuf;
			pTagDst = (uint64 *) (pDst + uOffsBuf);
			pDst = ((float *) pTagDst) + 4;	// increment by size of one Tag
			pTagDst = (uint64 *) (uint32(pTagDst)+uint32(SCRATCH_PAD));

			// Shuffle padding forward
			uint32 uRemQ = (uModMats1 != 0) ? (3 - uModMats1) : 0;
			for(int k=0; k<uRemQ; k++)
				((uint128 *) pTagDst)[0-k] = ((uint128 *) pTagDst)[-1-k];
			
			// Insert second tag
			pTagDst[0-uRemQ*2] = uTag2; pTagDst[1-uRemQ*2] = 0;

			uint32 uDiff = uLastNumMats-uNumMats1;
			if(uDiff>0)
				VU0ExecMats((void *) (uint32(pSrc1)+uint32(SCRATCH_PAD)), (void *) (uint32(pSrc2)+uint32(SCRATCH_PAD)), (void *) (uint32(pDst)+uint32(SCRATCH_PAD)), uDiff);
			else
				assert(uModMats1!=0);
		}
	}


	// Finish round (toggle)
	uLastNumMats = uNumMats;
	uLastPageIndex = uPageIndex;
	uLastStartOffs = uStartOffs;
	uMatBufToggle ^= 0x2000;
	++uPollNumber;
}

void FlushMats()
{
	ExecDMA_Mats(0, 0, 0, 1);	// FlushValue 1
	ExecDMA_Mats(0, 0, 0, 2);	// FlushValue 1
}


bool SetupDstTags(uint64 * pTag1, uint64 * pTag2)
{
	uint32 uEndOffs = uLastStartOffs + uLastNumMats*(12*4);
	bool bPageCrossing = uEndOffs > 4096;

	if(bPageCrossing)
	{
		uint32 uPage2 = uLastPageIndex + 1;
		uint32 uBSizeFromPage1 = 4096 - uLastStartOffs;
		uint32 uBSizeFromPage2 = uEndOffs - 4096;
		assert((uBSizeFromPage1&0xf)==0 && (uBSizeFromPage2&0xf)==0);

		uint32 uPhysA_Addr = PhysArrayDst[uLastPageIndex] + uLastStartOffs;
		uint32 uPhysB_Addr = PhysArrayDst[uPage2];

		*pTag1 = GEN_CNT_DSTTAG(uPhysA_Addr, uBSizeFromPage1>>4);
		*pTag2 = GEN_END_DSTTAG(uPhysB_Addr, uBSizeFromPage2>>4);
	}
	else
	{
		uint32 uQSize = (uEndOffs-uLastStartOffs)>>4;
		assert(((uEndOffs-uLastStartOffs)&0xf) == 0);
		uint32 uPhysAddr = PhysArrayDst[uLastPageIndex] + uLastStartOffs;

		// Uncached Writes
		*pTag1 = GEN_END_DSTTAG(uPhysAddr, uQSize);
		*pTag2 = 0;
	}

	return bPageCrossing;
}

void SetupSrcChain(uint32 uPageIndex, uint32 uStartOffs, uint32 uNumMats)
{
	uint32 uEndOffs = uStartOffs + uNumMats*(12*4);
	bool bPageCrossing = uEndOffs > 4096;

	if(bPageCrossing)
	{
		uint32 uPage2 = uPageIndex + 1;
		uint32 uBSizeFromPage1 = 4096 - uStartOffs;
		uint32 uBSizeFromPage2 = uEndOffs - 4096;
		assert((uBSizeFromPage1&0xf)==0 && (uBSizeFromPage2&0xf)==0);

		uint32 uPhysA_Addr1 = PhysArraySrc1[uPageIndex] + uStartOffs;
		uint32 uPhysB_Addr1 = PhysArraySrc1[uPage2];
		uint32 uPhysA_Addr2 = PhysArraySrc2[uPageIndex] + uStartOffs;
		uint32 uPhysB_Addr2 = PhysArraySrc2[uPage2];

		// Uncached Writes
		pToChain[0] = GEN_REF_TAG(uPhysA_Addr1, uBSizeFromPage1>>4);
		pToChain[2] = GEN_REF_TAG(uPhysB_Addr1, uBSizeFromPage2>>4);
		pToChain[4] = GEN_REF_TAG(uPhysA_Addr2, uBSizeFromPage1>>4);
		pToChain[6] = GEN_REF_TAG(uPhysB_Addr2, uBSizeFromPage2>>4);
		pToChain[8] = GEN_END_TAG(0);
	}
	else
	{
		uint32 uQSize = (uEndOffs-uStartOffs)>>4;
		assert(((uEndOffs-uStartOffs)&0xf) == 0);
		uint32 uPhysAddr1 = PhysArraySrc1[uPageIndex] + uStartOffs;
		uint32 uPhysAddr2 = PhysArraySrc2[uPageIndex] + uStartOffs;

		// Uncached Writes
		pToChain[0] = GEN_REF_TAG(uPhysAddr1, uQSize);
		pToChain[2] = GEN_REF_TAG(uPhysAddr2, uQSize);
		pToChain[4] = GEN_END_TAG(0);
	}
}






// API (virtual pointers)
void MatMulMat(void * pSrc1, void * pSrc2, void * pDst, uint32 uTotNumMats)
{
	// Chop off valid sizes
	uint32 uRemain = uTotNumMats;
	uint32 uStartOffs = 0;
	uint32 uPageIndex = 0;

	while(uRemain > 0)
	{
		assert(uStartOffs < 0x1000);
		uint32 uNumDelivery = (uRemain < uMaxMatArrayLens) ? uRemain : uMaxMatArrayLens;

		ExecDMA_Mats(uPageIndex, uStartOffs, uNumDelivery);

		// Increase page index
		uStartOffs += (uNumDelivery*(12*4));
		if(uStartOffs >= 4096)
			++uPageIndex;

		uStartOffs &= 0xfff;
		uRemain -= uNumDelivery;
	}

	FlushMats();
}

void InitMatDma(uint32 * pTblSrc1, uint32 * pTblSrc2, uint32 * pTblDst, uint64 * pChainMem, uint64 * pPhysChain)
{
	// Setup phys-pointer lookup tables and ChainMem
	PhysArraySrc1 = pTblSrc1;
	PhysArraySrc2 = pTblSrc2;
	PhysArrayDst = pTblDst;
	//pToChain = (uint64 *) (((uint32) pChainMem) | 0x20000000);
	pToChain = pChainMem;
	pToPhysChain = pPhysChain;

	// make sure everyone is idle
	uint16 uTmp;
	while ((*EE_D8_CHCR) & (1<<8));
	while ((*EE_D9_CHCR) & (1<<8));
	asm __volatile__("	CFC2.i	%0, $vi01 " : "=r" (uTmp) );

	// Upload VU0Code
	uint32 iLengthCodeInQuads = (((uint32)&VU_vu0matmulmat_end - (uint32)&VU_vu0matmulmat_start) + 15) >> 4;
	assert(iLengthCodeInQuads == 13);
	uint128 * pDst = (uint128 *) VU0_MICRO_MEM;
	uint128 * pSrc = (uint128 *) &VU_vu0matmulmat_start;

	for(int q=0; q<iLengthCodeInQuads; q++)
		*pDst++ = *pSrc++;

	// Clear VIF code fields of SrcRefChain
	pToChain[1]=0; pToChain[3]=0; pToChain[5]=0;
	pToChain[7]=0; pToChain[9]=0;

	uPollNumber = 0;
	uMatBufToggle = 0;
}
